<template>
  <div>
    <div class="jeecg-basic-table-form-container" @keyup.enter="searchQuery">
      <a-form :model="queryParam" :label-col="labelCol" :wrapper-col="wrapperCol">
        <a-row :gutter="24">
          <a-col :lg="6">
            <a-form-item :label="searchFormSchema[0].label">
              <JInput type="like" placeholder="请输入" v-model:value="queryParam[searchFormSchema[0].field]" allowClear="true" />
            </a-form-item>
          </a-col>
          <a-col :lg="6">
            <a-form-item :label="searchFormSchema[1].label">
              <JSearchSelect v-model:value="queryParam[searchFormSchema[1].field]" placeholder="全部" dict="applyrange" allowClear="true" />
            </a-form-item>
          </a-col>
          <a-col :lg="6">
            <a-form-item :label="searchFormSchema[2].label">
              <JSearchSelect v-model:value="queryParam[searchFormSchema[2].field]" placeholder="全部" dict="filestatus" allowClear="true" />
            </a-form-item>
          </a-col>
          <a-col :lg="6">
            <a-form-item>
              <a-space :size="5">
                <a-button type="primary" preIcon="ant-design:search-outlined" @click="searchQuery">查询</a-button>
                <a-button type="primary" preIcon="ant-design:reload-outlined" @click="searchReset">重置</a-button>
              </a-space>
            </a-form-item>
          </a-col>
        </a-row>
      </a-form>
      <!--引用表格-->
      <BasicTable @register="registerTable" :rowSelection="rowSelection">
        <!--插槽:table标题-->
        <template #tableTitle>
          <a-button type="primary" @click="handleAdd" preIcon="ant-design:plus-outlined"> 新建</a-button>
          <a-button v-show="showBtn" type="primary" preIcon="ant-design:export-outlined" @click="onExportXls"> 导出</a-button>
          <j-upload-button v-show="showBtn" type="primary" preIcon="ant-design:import-outlined" @click="onImportXls">导入</j-upload-button>
          <a-dropdown v-if="selectedRowKeys.length > 0 && showBtn">
            <template #overlay>
              <a-menu>
                <a-menu-item key="1" @click="batchHandleDelete">
                  <Icon icon="ant-design:delete-outlined" />
                  删除
                </a-menu-item>
              </a-menu>
            </template>
            <a-button
              >批量操作
              <Icon icon="mdi:chevron-down" />
            </a-button>
          </a-dropdown>
        </template>
        <!--操作栏-->
        <template #action="{ record }">
          <TableAction :actions="getTableAction(record)" :dropDownActions="getDropDownAction(record)" />
        </template>
        <!--字段回显插槽-->
        <template #htmlSlot="{ text }">
          <div v-html="text"></div>
        </template>
        <!--省市区字段回显插槽-->
        <template #pcaSlot="{ text }">
          {{ getAreaTextByCode(text) }}
        </template>
        <template #fileSlot="{ text }">
          <span v-if="!text" style="font-size: 12px; font-style: italic">无文件</span>
          <a-button v-else :ghost="true" type="primary" preIcon="ant-design:download-outlined" size="small" @click="downloadFile(text)"
            >下载</a-button
          >
        </template>
      </BasicTable>
    </div>
    <!-- 表单区域 -->
    <StBestCaseModal @register="registerModal" @success="handleSuccess" />
    <!-- 引入文档管理 -->
    <DocFilesList @register="registerFileModal" />
  </div>
</template>

<script lang="ts" name="standardlib-StBestCaseList" setup>
  import { reactive, ref, toRaw, unref } from 'vue';
  import { batchDelete, deleteOne, getExportUrl, getImportUrl, list } from './StBestCase.api';
  import { columns, searchFormSchema } from './StBestCase.data';
  import StBestCaseModal from './components/StBestCaseModal.vue';
  import { JInput, JSearchSelect } from '/@/components/Form';
  import { useModal } from '/@/components/Modal';
  import { BasicTable, TableAction } from '/@/components/Table';
  import { useListPage } from '/@/hooks/system/useListPage';
  import { downloadFile } from '/@/utils/common/renderUtils';
  import DocFilesList from '/@/views/standardlib/compliane/components/DocFileListModal.vue';
  // const route = useRoute();
  const showBtn = ref(false);
  const checkedKeys = ref<Array<string | number>>([]);
  //注册model
  const [registerModal, { openModal }] = useModal();
  const [registerFileModal, { openModal: openFileModal }] = useModal();
  //注册table数据
  const { prefixCls, tableContext, onExportXls, onImportXls } = useListPage({
    tableProps: {
      title: 'st_best_case',
      api: list,
      columns,
      canResize: false,
      showTableSetting: false,
      useSearchForm: false,
      formConfig: {
        //labelWidth: 120,
        schemas: searchFormSchema,
        autoSubmitOnEnter: true,
        showAdvancedButton: true,
        fieldMapToNumber: [],
        fieldMapToTime: [],
      },
      actionColumn: {
        width: 160,
        fixed: 'right',
      },
      beforeFetch(params) {
        params = Object.assign(params, { column: 'updatedTime', order: 'desc' });
      },
    },
    exportConfig: {
      name: 'st_best_case',
      url: getExportUrl,
    },
    importConfig: {
      url: getImportUrl,
      success: handleSuccess,
    },
  });

  const [registerTable, { reload, setProps }, { rowSelection, selectedRowKeys }] = tableContext;
  //-----自定义查询----begin--------
  const labelCol = reactive({
    xs: { span: 24 },
    sm: { span: 8 },
  });
  const wrapperCol = reactive({
    xs: { span: 24 },
    sm: { span: 16 },
  });
  const queryParam = reactive({});
  function initParam() {
    const schemas = unref(searchFormSchema);
    schemas.forEach((item) => {
      queryParam[item.field] = '';
    });
  }
  initParam();
  function searchQuery() {
    setProps({ searchInfo: toRaw(queryParam) });
    reload();
  }
  function searchReset() {
    //Object.assign(queryParam,{ name: '',age_begin: '',age_end: '',sex: '',id: ''});
    initParam();
    reload();
  }
  //自定义查询----end---------
  /**
   * 新增事件
   */
  function handleAdd() {
    openModal(true, {
      isUpdate: false,
      showFooter: true,
    });
  }
  /**
   * 编辑事件
   */
  function handleEdit(record: Recordable) {
    openModal(true, {
      record,
      isUpdate: true,
      showFooter: true,
    });
  }
  /**
   * 详情
   */
  function handleDetail(record: Recordable) {
    openModal(true, {
      record,
      isUpdate: true,
      showFooter: false,
    });
  }
  /**
   * 删除事件
   */
  async function handleDelete(record) {
    await deleteOne({ id: record.id }, handleSuccess);
  }
  /**
   * 批量删除事件
   */
  async function batchHandleDelete() {
    await batchDelete({ ids: selectedRowKeys.value }, handleSuccess);
  }
  /**
   * 关联附件
   */
  function handleFile(record) {
    openFileModal(true, {
      record,
      isUpdate: true,
      showFooter: false,
    });
  }
  /**
   * 成功回调
   */
  function handleSuccess() {
    (selectedRowKeys.value = []) && reload();
  }
  /**
   * 操作栏
   */
  function getTableAction(record) {
    return [
      {
        label: '删除',
        color: 'error',
        popConfirm: {
          title: '你确定要删除选中的文件吗？',
          confirm: handleDelete.bind(null, record),
        },
      },
      {
        label: '修改',
        onClick: handleEdit.bind(null, record),
      },
      {
        label: '详情',
        onClick: handleDetail.bind(null, record),
      },
      {
        label: '附件',
        onClick: handleFile.bind(null, record),
      },
    ];
  }
  /**
   * 下拉操作栏
   */
  function getDropDownAction(record) {
    return [];
  }
</script>

<style scoped>
  :deep(.ant-layout-sider) {
    background: #fff !important;
  }
</style>
